#!/itl/links/generic/bin/expect

global env nplot

#  provide other required tcl code

set wdpdir /home/lipman/public_html/cgi-bin
set auto_path [linsert $auto_path 0 $wdpdir]
package require cgi
source [file join $wdpdir wdpsite.tcl]
source [file join $wdpdir wdputil.tcl]

set nplot 0

cgi_eval {

   cgi_input
   foreach var {dpcmds fback} {
      if [catch {cgi_import $var}] {set $var ""}
   }
   set dpcmds [split $dpcmds \n]
   
   set boundary "ThisRandomString"

#  start html
   cgi_html {

#  page header
      cgi_http_head {
         cgi_content_type "multipart/x-mixed-replace;boundary=$boundary"
         puts \n--$boundary
         cgi_content_type
      }
      cgi_title "WebDataplot"

#  page body
      cgi_body bgcolor=#ffffff {

#  spawn datatplot
         if {$dpcmds != ""} {
            cgi_h3 "Spawning Dataplot ..."
	    log_user 0
	    if [catch {exp_spawn /usr/local/bin/dataplot} err] {
	       ErrMsg "ERROR: $err"
	    } else {
	       exp_match_max 100000
	       expect -re ">"

#  dataplot spawned properly, send commands
	       if {[info exists expect_out(buffer)]} {
		  puts <PRE>
        	  set output $expect_out(buffer)
        	  PrintOutput $output
        	  SendDP "SET HELP LINES 10000"
        	  if {$fback == "OFF"} {SendDP "FEEDBACK OFF"}
        	  if {[llength $dpcmds] == 1} {
        	     set cmd [join $dpcmds]
        	     if {[string range $cmd 0 3] == "CALL"} {
        	        SendDP "LIST [string range $cmd 5 end]"
        	     }
        	     lappend dpcmds "EXIT"
        	  }
        	  foreach cmd $dpcmds {
        	    if {$cmd != "" && $cmd != "."} {SendDP $cmd}
        	  }
		  puts </PRE>

#  dataplot did not spawn properly
               } else {
        	  ErrMsg "ERROR: Dataplot did not spawn properly, reload the web page"
               }
            }

#  no dataplot commands
         } else {
            ErrMsg "ERROR: No Dataplot commands"
         }
      }
   }
}
